
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C20B83  ; location in v1.0 and v1.1
;org $C20B7B  ; location in SFC version only
C20B83:	PHP
	PHX
C20B85:	SEP #$20  ; 8-bit A
C20B87:	LDA $11A6  ; get battle power
C20B8A:	BNE begin_alg  ; if power is 0...

new_exit:
REPLACE1:  ; three instructions replace one
C20B8C:	PLX
C20B8D:	PLP
C20B8E:	RTS
;C20B8C:	JMP old_exit

C20B8F:	LDA $11A4  ; special byte 2
C20B92:	BMI hp_mp_damage
C20B94:	JSR $0C9E  ; v1.0 or v1.1
;C20B94:	JSR $0C96  ; SFC only
C20B97:	BRA zombie_petrify_check

hp_mp_damage:
C20B99:	JSR $0D87  ; v1.0 or v1.1
;C20B99:	JSR $0D7F  ; SFC only

zombie_petrify_check:
C20B9C:	STZ $F2
	LDA $3DFC,Y  ; get statuses to remove
	AND $3EE4,Y  ; check against statuses target has
	BIT #$02  ; if Zombie check passed...
	BNE init_heal_flag  ; ...skip Petrify check
C20BA8:	LDA $3EE4,Y
C20BAB:	ASL A
C20BAC:	BMI zero_damage  ; zero damage if target is Petrified

init_heal_flag:
C20BAE:	LDA $11A4
C20BB1:	STA $F2
C20BB3:	LDA $11A2
C20BB6:	BIT #$08  ; invert damage if Undead?
C20BB8:	BEQ elements  ; branch if not
C20BBA:	LDA $3C95,Y
C20BBD:	BPL zombie_redirect_check  ; branch if not Undead
C20BBF:	LDA $11AA  ; get attack statuses
C20BC2:	BIT #$82  ; if attack inflicts Wound or Zombie...
REPLACE2:  ; ...exit
C20BC4:	BNE new_exit  ; the only change here is the branch label/offset
;C20BC4:	BNE old_exit
C20BC6:	STZ $F2
	LDA #$02
C20BCA:	BRA redirect_check

zombie_redirect_check:
C20BCC:	LDA $3EE4,Y  ; target entity's statuses
REPLACE3:  ; one instruction replaces two
C20BCF:	AND #$02  ; check for Zombie
;C20BCF:	BIT #$02
;C20BD0:	BEQ elements

redirect_check:
REPLACE4:  ; two instructions replace four
C20BD1:	AND $11A4  ; check for redirection
C20BD4:	LSR A  ; align check result(s) to with heal flag
;C20BD1:	LDA $11A4
;C20BD2:	BIT #$02
;C20BD3:	BEQ elements
;C20BD4:	LDA $F2

flip_heal:
REPLACE5:  ; one replaces one
C20BD5:	EOR $F2
;C20BD5:	EOR #$01
C20BD7:	STA $F2

elements:
C20BD9:	LDA $11A1  ; get attack elements
C20BDC:	BEQ pull_x  ; branch if none
C20BDE:	LDA $3EC8  ; get elements cancelled by Forcefield
C20BE1:	EOR #$FF
C20BE3:	AND $11A1  ; check attack elements
C20BE6:	BEQ zero_damage  ; if any were cancelled, damage is 0
	TYX  ; copy target index
	LDA $11A1
REPLACE6:  ; two instructions replace one
C20BEC:	BIT $3BCC,X  ; check absorbed elements
;C20BEC:	LDA $3BCC,Y
;C20BED:	BIT $11A1
C20BEF:	BEQ zero_elements  ; branch if none
C20BF1:	LDA $F2
C20BF3:	EOR #$01  ; flip heal flag
C20BF5:	STA $F2
C20BF7:	BRA pull_x

zero_elements:
REPLACE7:  ; two instructions replace one
C20BF9:	BIT $3BCD,X  ; check blocked elements
;C20BF9:	LDA $3BCD,Y
;C20BFA:	BIT $11A1
C20BFC:	BEQ half_elements  ; branch if none

zero_damage:
C20BFE:	STZ $F0
C20C00:	STZ $F1
	PLX
C20C03:	BRA atma_check

half_elements:
REPLACE8:  ; two instructions replace one
C20C05:	BIT $3BE1,X  ; check halved elements
;C20C05:	LDA $3BCD,Y
;C20C06:	BIT $11A1
C20C08:	BEQ weak_elements  ; branch if none
C20C0A:	LSR $F1
C20C0C:	ROR $F0  ; damage cut in half
C00C0E:	BRA pull_x

weak_elements:
REPLACE9:  ; two instructions replace one
C20C10:	BIT $3BE0,X  ; check weakness elements
;C20C10:	LDA $3BE0,Y
;C20C11:	BIT $11A1
C20C13:	BEQ pull_x  ; branch if none
C20C15:	LDA $F1
C20C17:	BMI pull_x  ; don't double damage if it's at least 32,768
C20C19:	ASL $F0
C20C1B:	ROL $F1  ; damage is doubled

pull_x:
C20C1D:	PLX

atma_check:
C20C1E:	LDA $11A9  ; get attack effect
C20C21:	CMP #$04  ; if it's Atma Weapon...
C20C23:	BNE after_atma  ; ...call Atma Weapon damage algorithm
C20C25:	JSR $0E39  ; v1.0 or v1.1
;C20C25:	JSR $0E31  ; SFC only

after_atma:
C20C28:	JSR finish_damage_mod

old_exit:
C20C2B:	PLP
C20C2C:	RTS

finish_damage_mod:

;org $C20BC6  ; location in v1.0 and v1.1
;org $C20BBE  ; location in SFC version only
;	LDA #$01  ; uncomment these changes to add Master ZED's
;	BRA flip_heal  ; "Invert Damage if Undead" fix

;org $C20C03  ; location in v1.0 and v1.1
;org $C20BFB  ; location in SFC version only
;	BRA after_atma  ; uncomment to add Imzogelmo's "Carve Stone" fix